Index: sandbox/workflow/branches/609/showUserPicture.php
===================================================================
--- sandbox/workflow/branches/609/showUserPicture.php	(revision 1468)
+++ sandbox/workflow/branches/609/showUserPicture.php	(revision 2233)
@@ -12,4 +12,4 @@
 if (empty($_SESSION))
 	exit(0);
-$GLOBALS['workflow']['factory']->getInstance('UserPictureProvider')->serve();
+Factory::getInstance('UserPictureProvider')->serve();
 ?>
Index: sandbox/workflow/branches/609/templateFile.php
===================================================================
--- sandbox/workflow/branches/609/templateFile.php	(revision 2223)
+++ sandbox/workflow/branches/609/templateFile.php	(revision 2233)
@@ -12,5 +12,4 @@
 if (empty($_SESSION))
 	exit(0);
-//$GLOBALS['workflow']['factory']->getInstance('TemplateServer')->redirect();
 Factory::getInstance('TemplateServer')->redirect();
 ?>
Index: sandbox/workflow/branches/609/lib/factory/BaseFactory.php
===================================================================
--- sandbox/workflow/branches/609/lib/factory/BaseFactory.php	(revision 2222)
+++ sandbox/workflow/branches/609/lib/factory/BaseFactory.php	(revision 2233)
@@ -154,7 +154,7 @@
 		/* not found */
 		if (!($entry = $this->_getEntry($className)))
-			throw new Exception('You are not allowed to instantiate '.$className.' class.');
+			throw new Exception('You are not allowed to instantiate \''.$className.'\' class.');
 
-		$fullPath = $entry['basePath'] . SEP . $entry['path'] . SEP . $entry['filename'];
+		$fullPath = $entry['basePath'] . '/' . $entry['path'] . '/' . $entry['filename'];
 
 		/* file not found */
Index: sandbox/workflow/branches/609/lib/factory/WorkflowFactory.php
===================================================================
--- sandbox/workflow/branches/609/lib/factory/WorkflowFactory.php	(revision 2223)
+++ sandbox/workflow/branches/609/lib/factory/WorkflowFactory.php	(revision 2233)
@@ -49,9 +49,22 @@
 		/* registering allowed classes */
 		$this->registerFileInfo('WorkflowObjects', 'class.WorkflowObjects.inc.php', 'inc');
+		$this->registerFileInfo('WorkflowWatcher', 'class.WorkflowWatcher.inc.php', 'inc');
+		$this->registerFileInfo('WorkflowLDAP', 'class.WorkflowLDAP.inc.php', 'inc');
+		$this->registerFileInfo('WorkflowSecurity', 'class.WorkflowSecurity.inc.php', 'inc');
+		$this->registerFileInfo('ResourcesRedirector', 'class.ResourcesRedirector.inc.php', 'inc');
 		$this->registerFileInfo('TemplateServer', 'class.TemplateServer.inc.php', 'inc');
+		$this->registerFileInfo('CachedLDAP', 'class.CachedLDAP.inc.php', 'inc');
+		$this->registerFileInfo('BrowserInfo', 'class.BrowserInfo.inc.php', 'inc');
+
 		$this->registerFileInfo('workflow_smarty', 'class.workflow_smarty.inc.php', 'inc');
+		$this->registerFileInfo('workflow_acl', 'class.workflow_acl.inc.php', 'inc');
+		$this->registerFileInfo('workflow_processmanager', 'class.workflow_processmanager.inc.php', 'inc');
+
+		$this->registerFileInfo('bo_participants', 'class.bo_participants.inc.php', 'inc');
 
 		/* registering egw class example */
-		//$this->registerFileInfo('db', 'x', 'inc', PHPGW_API_INC);
+		$this->registerFileInfo('phpgw', 'class.phpgw.inc.php', '', EGW_INC_ROOT);
+		$this->registerFileInfo('db', 'class.db.inc.php', '', EGW_INC_ROOT);
+		$this->registerFileInfo('accounts', 'class.accounts.inc.php', '', EGW_INC_ROOT);
 
 		/* ok. no more instances of this class.. */
Index: sandbox/workflow/branches/609/lib/factory/Factory.php
===================================================================
--- sandbox/workflow/branches/609/lib/factory/Factory.php	(revision 2223)
+++ sandbox/workflow/branches/609/lib/factory/Factory.php	(revision 2233)
@@ -64,5 +64,5 @@
 	 * @static
 	 */
-	public static function getInstance() {
+	public static function &getInstance() {
 
 		/* oops. we are in the process space. */
@@ -93,10 +93,31 @@
 	 * Just forward this call to the correct class.
 	 *
-	 * @todo I must implement it!
 	 * @access public
 	 * @retun object
 	 * @static
 	 */
-	public static function newInstance() {
+	public static function &newInstance() {
+
+		/* oops. we are in the process space. */
+		if (Security::isEnabled()) {
+
+			/* must instatiate it */
+			if (is_null(self::$_securedFactory))
+				self::$_securedFactory = new ProcessFactory();
+
+			$args = func_get_args();
+			return call_user_func_array(array(self::$_securedFactory, "newInstance"), $args);
+
+		}
+		/* regular module space */
+		else {
+
+			/* must instatiate it */
+			if (is_null(self::$_unsecuredFactory))
+				self::$_unsecuredFactory = new WorkflowFactory();
+
+			$args = func_get_args();
+			return call_user_func_array(array(self::$_unsecuredFactory, "newInstance"), $args);
+		}
 	}
 }
Index: sandbox/workflow/branches/609/redirect.php
===================================================================
--- sandbox/workflow/branches/609/redirect.php	(revision 1468)
+++ sandbox/workflow/branches/609/redirect.php	(revision 2233)
@@ -12,4 +12,4 @@
 if (empty($_SESSION))
 	exit(0);
-$GLOBALS['workflow']['factory']->getInstance('ResourcesRedirector')->redirect();
+Factory::getInstance('ResourcesRedirector')->redirect();
 ?>
Index: sandbox/workflow/branches/609/controller.php
===================================================================
--- sandbox/workflow/branches/609/controller.php	(revision 1484)
+++ sandbox/workflow/branches/609/controller.php	(revision 2233)
@@ -16,5 +16,5 @@
 	{
 		require_once dirname(__FILE__) . '/inc/common.inc.php';
-		$GLOBALS['workflow']['factory']->getInstance('WorkflowMacro')->prepareEnvironment();
+		Factory::getInstance('WorkflowMacro')->prepareEnvironment();
 	}
 
Index: sandbox/workflow/branches/609/inc/class.workflow_processmonitor.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.workflow_processmonitor.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.workflow_processmonitor.inc.php	(revision 2233)
@@ -17,5 +17,5 @@
 		function workflow_processmonitor()
 		{
-			parent::ProcessMonitor($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::ProcessMonitor(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/branches/609/inc/class.bo_utils.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.bo_utils.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.bo_utils.inc.php	(revision 2233)
@@ -34,5 +34,5 @@
 	{
 		parent::bo_ajaxinterface();
-		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBExpresso();
+		$this->db =& Factory::getInstance('WorkflowObjects')->getDBExpresso();
 	}
 
Index: sandbox/workflow/branches/609/inc/class.run_activity.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.run_activity.inc.php	(revision 2072)
+++ sandbox/workflow/branches/609/inc/class.run_activity.inc.php	(revision 2233)
@@ -301,5 +301,5 @@
 			$this->process_version	= $this->process->getVersion();
 			$this->activity_name	= $activity->getName();
-			$this->user_name	= $GLOBALS['phpgw']->accounts->id2name($GLOBALS['user']);
+			$this->user_name	= Factory::getForeignInstance('phpgwapi', 'phpgw')->accounts->id2name($GLOBALS['user']);
 			$this->view_activity	= $this->GUI->gui_get_process_view_activity($this->process_id);
 
@@ -318,8 +318,8 @@
 			$GLOBALS['workflow']['wf_workflow_path']			= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow';
 			$GLOBALS['workflow']['wf_resources_path']			= $GLOBALS['phpgw_info']['server']['webserver_url'] . SEP . 'workflow/redirect.php?pid=' . $this->process_id . '&file=';
-			$GLOBALS['workflow']['wf_default_resources_path']	= $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateLink('processes');
-			$GLOBALS['workflow']['wf_workflow_resources_path']	= $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateLink('');
+			$GLOBALS['workflow']['wf_default_resources_path']	= Factory::getInstance('TemplateServer')->generateLink('processes');
+			$GLOBALS['workflow']['wf_workflow_resources_path']	= Factory::getInstance('TemplateServer')->generateLink('');
 			$GLOBALS['workflow']['wf_activity_url']				= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'index.php?menuaction=workflow.'.get_class($this).'.go&activity_id='.$activity_id;
-			$GLOBALS['workflow']['wf_user_cnname']				= $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($GLOBALS['user']);
+			$GLOBALS['workflow']['wf_user_cnname']				= Factory::getInstance('WorkflowLDAP')->getName($GLOBALS['user']);
 			$GLOBALS['workflow']['wf_back_link']				= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow'.SEP.'index.php?start_tab=1';
 			$GLOBALS['workflow']['wf_js_path']					= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow'.SEP.'js'.SEP.'jscode';
@@ -376,5 +376,5 @@
 
 				/* check some permissions */
-				if (($newUser == '*') || (!$this->runtime->checkUserRun($newUser)) || ($GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($newUser) === false))
+				if (($newUser == '*') || (!$this->runtime->checkUserRun($newUser)) || (Factory::getInstance('WorkflowLDAP')->getName($newUser) === false))
 				{
 					$_SESSION['phpgw_info']['workflow']['user_groups'] = $actualUserGroups;
@@ -472,5 +472,5 @@
 
 			/* activate the security policy */
-			$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->enableSecurityPolicy();
+			Factory::getInstance('WorkflowSecurity')->enableSecurityPolicy();
 
 			/* include the files */
@@ -661,8 +661,8 @@
 			$GLOBALS['workflow']['wf_workflow_path']			= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow';
 			$GLOBALS['workflow']['wf_resources_path']			= $GLOBALS['phpgw_info']['server']['webserver_url'] . SEP . 'workflow/redirect.php?pid=' . $this->process_id . '&file=';
-			$GLOBALS['workflow']['wf_default_resources_path']	= $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateLink('processes');
-			$GLOBALS['workflow']['wf_workflow_resources_path']	= $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateLink('');
+			$GLOBALS['workflow']['wf_default_resources_path']	= Factory::getInstance('TemplateServer')->generateLink('processes');
+			$GLOBALS['workflow']['wf_workflow_resources_path']	= Factory::getInstance('TemplateServer')->generateLink('');
 			$GLOBALS['workflow']['wf_activity_url']				= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'index.php?menuaction=workflow.'.get_class($this).'.go&activity_id='.$activity_id;
-			$GLOBALS['workflow']['wf_user_cnname']				= $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($GLOBALS['user']);
+			$GLOBALS['workflow']['wf_user_cnname']				= Factory::getInstance('WorkflowLDAP')->getName($GLOBALS['user']);
 			$GLOBALS['workflow']['wf_back_link']				= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow'.SEP.'index.php?start_tab=1';
 			$GLOBALS['workflow']['wf_js_path']					= $GLOBALS['phpgw_info']['server']['webserver_url'].SEP.'workflow'.SEP.'js'.SEP.'jscode';
@@ -712,5 +712,5 @@
 
 			/* activate the security policy */
-			$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->enableSecurityPolicy();
+			Factory::getInstance('WorkflowSecurity')->enableSecurityPolicy();
 
 			$GLOBALS['workflow_env'] = &$env;
Index: sandbox/workflow/branches/609/inc/class.workflow_baseactivity.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.workflow_baseactivity.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.workflow_baseactivity.inc.php	(revision 2233)
@@ -17,5 +17,5 @@
 		function workflow_baseactivity()
 		{
-			parent::BaseActivity($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::BaseActivity(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/branches/609/inc/class.workflow_acl.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.workflow_acl.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.workflow_acl.inc.php	(revision 2233)
@@ -30,5 +30,5 @@
 	function workflow_acl()
 	{
-		parent::so_adminaccess($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		parent::so_adminaccess(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 	}
 
Index: sandbox/workflow/branches/609/inc/class.bo_adminaccess.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.bo_adminaccess.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.bo_adminaccess.inc.php	(revision 2233)
@@ -43,8 +43,8 @@
 		parent::bo_ajaxinterface();
 
-		if (!$GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($_SESSION['phpgw_info']['workflow']['account_id']))
+		if (!Factory::getInstance('workflow_acl')->checkWorkflowAdmin($_SESSION['phpgw_info']['workflow']['account_id']))
 			exit(serialize(array('error' => 'Você não tem permissão para executar esta operação.')));
 
-		$this->so = new so_adminaccess($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$this->so = new so_adminaccess(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 	}
 
@@ -57,5 +57,5 @@
 	function get_all_processes()
 	{
-		$proc_mng = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$proc_mng = new ProcessManager(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		$proc_list = $proc_mng->list_processes(0,-1,'wf_name__ASC');
 
Index: sandbox/workflow/branches/609/inc/class.ui_userinterface.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.ui_userinterface.inc.php	(revision 2223)
+++ sandbox/workflow/branches/609/inc/class.ui_userinterface.inc.php	(revision 2233)
@@ -115,8 +115,8 @@
 
 		// Get a connection to db workflow and galaxia (module)
-		if ($GLOBALS['workflow']['workflowObjects']->getDBWorkflow()->Error)
+		if (Factory::getInstance('WorkflowObjects')->getDBWorkflow()->Error)
 			$errors[] = 'Unable to connect to database Workflow';
 
-		if ($errormsg = $GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Error)
+		if ($errormsg = Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Error)
 			$errors[] = 'Unable to connect to database Galaxia';
 
Index: sandbox/workflow/branches/609/inc/class.TemplateServer.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.TemplateServer.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.TemplateServer.inc.php	(revision 2233)
@@ -99,5 +99,5 @@
 				else
 				{
-					$GLOBALS['workflow']['factory']->getInstance('WorkflowMacro')->prepareEnvironment();
+					Factory::getInstance('WorkflowMacro')->prepareEnvironment();
 					if (!isset($GLOBALS['phpgw_info']['login_template_set']))
 						return false;
@@ -131,5 +131,5 @@
 				{
 					/* se não for encontrado em nenhuma variável de ambiente, tenta carregar do banco de dados */
-					$webServerURL = (string) $GLOBALS['workflow']['workflowObjects']->getDBExpresso()->Link_ID->GetOne('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'webserver_url'));
+					$webServerURL = (string) Factory::getInstance('WorkflowObjects')->getDBExpresso()->Link_ID->GetOne('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'webserver_url'));
 					$this->WEB_WORKFLOW_BASE = str_replace('//', '/', "{$webServerURL}/workflow");
 				}
Index: sandbox/workflow/branches/609/inc/class.ui_adminjobs.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.ui_adminjobs.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.ui_adminjobs.inc.php	(revision 2233)
@@ -41,5 +41,5 @@
 			'app_header' => $GLOBALS['phpgw_info']['apps']['workflow']['title'] . ' - ' . lang('Jobs')
 		);
-		$smarty = &$GLOBALS['workflow']['factory']->getInstance('workflow_smarty');
+		$smarty = &Factory::getInstance('workflow_smarty');
 
 		$javaScripts = $this->get_common_js();
@@ -54,5 +54,5 @@
 		$css .= $this->get_css_link('adminjobs');
 
-		$processInfo = $GLOBALS['workflow']['factory']->getInstance('workflow_processmanager')->get_process((int) $_REQUEST['p_id']);
+		$processInfo = Factory::getInstance('workflow_processmanager')->get_process((int) $_REQUEST['p_id']);
 		$smarty->assign('processNameVersion', "{$processInfo['wf_name']} v{$processInfo['wf_version']}");
 		$smarty->assign('processID', (int) $processInfo['wf_p_id']);
Index: sandbox/workflow/branches/609/inc/class.workflow_processmanager.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.workflow_processmanager.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.workflow_processmanager.inc.php	(revision 2233)
@@ -26,5 +26,5 @@
 			'database_user',
 			'database_password'
-		); 
+		);
 	   /**
 		 * Constructor
@@ -34,7 +34,7 @@
 		function workflow_processmanager()
 		{
-			parent::ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::ProcessManager(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 			$this->workflow_acl = CreateObject('workflow.workflow_acl');
-			
+
 			/* allow regular users to see the process graph */
 			if ($_GET['menuaction'] == "workflow.ui_adminactivities.show_graph")
Index: sandbox/workflow/branches/609/inc/class.ui_generic_select.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.ui_generic_select.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.ui_generic_select.inc.php	(revision 2233)
@@ -79,5 +79,5 @@
 	function form()
 	{
-		$smarty = $GLOBALS['workflow']['factory']->getInstance('workflow_smarty', false);
+		$smarty = Factory::getInstance('workflow_smarty', false);
 		$smarty->setHeader(workflow_smarty::SHOW_HEADER | workflow_smarty::SHOW_FOOTER);
 
Index: sandbox/workflow/branches/609/inc/class.CachedLDAP.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.CachedLDAP.inc.php	(revision 1310)
+++ sandbox/workflow/branches/609/inc/class.CachedLDAP.inc.php	(revision 2233)
@@ -97,8 +97,8 @@
 
 		/* load the information and establish a connection */
-		$tmpLDAP = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$tmpLDAP =& Factory::getInstance('WorkflowLDAP');
 		$this->userContext  = $tmpLDAP->getUserContext();
 		$this->groupContext = $tmpLDAP->getGroupContext();
-		$this->dataSource = &$GLOBALS['workflow']['workflowObjects']->getLDAP();
+		$this->dataSource =& Factory::getInstance('WorkflowObjects')->getLDAP();
 	}
 
@@ -115,5 +115,5 @@
 
 		/* establish a connection */
-		$this->DBLink = &$GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID;
+		$this->DBLink =& Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID;
 	}
 
Index: sandbox/workflow/branches/609/inc/class.ui_adminprocesses.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.ui_adminprocesses.inc.php	(revision 989)
+++ sandbox/workflow/branches/609/inc/class.ui_adminprocesses.inc.php	(revision 2233)
@@ -127,5 +127,5 @@
 		}
 
-		if (!$GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
+		if (!Factory::getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
 		{
 			$proc_ids = $this->workflow_acl->get_granted_processes($GLOBALS['phpgw_info']['user']['account_id']);
@@ -589,5 +589,5 @@
 
 			$myp_id = $item['wf_p_id'];
-			$templateServer = &$GLOBALS['workflow']['factory']->getInstance('TemplateServer');
+			$templateServer = &Factory::getInstance('TemplateServer');
 			$this->t->set_var(array(
 				'item_wf_p_id'		=> $myp_id,
Index: sandbox/workflow/branches/609/inc/class.so_move_instances.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.so_move_instances.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.so_move_instances.inc.php	(revision 2233)
@@ -91,6 +91,6 @@
 		$this->userID = $_SESSION['phpgw_info']['workflow']['account_id'];
 		$this->isAdmin = $_SESSION['phpgw_info']['workflow']['user_is_admin'];
-		$this->acl = &$GLOBALS['ajax']->acl;
-		$this->db = &$GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID;
+		$this->acl =& $GLOBALS['ajax']->acl;
+		$this->db =& Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID;
 	}
 
Index: sandbox/workflow/branches/609/inc/class.workflow_activitymanager.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.workflow_activitymanager.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.workflow_activitymanager.inc.php	(revision 2233)
@@ -20,5 +20,5 @@
 		function workflow_activitymanager()
 		{
-			parent::ActivityManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::ActivityManager(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/branches/609/inc/class.WorkflowObjects.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.WorkflowObjects.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.WorkflowObjects.inc.php	(revision 2233)
@@ -87,5 +87,5 @@
 			{
 				/* connect to the database */
-				$this->cache['DBGalaxia'] = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $GLOBALS['workflow']['factory']->newForeignInstance('phpgwapi', 'db'));
+				$this->cache['DBGalaxia'] = Factory::newInstance('WorkflowWatcher', Factory::newInstance('db'));
 				$this->cache['DBGalaxia']->disconnect(); /* for some reason it won't connect to the desired database unless we disconnect it first */
 				$this->cache['DBGalaxia']->Halt_On_Error = 'no';
@@ -98,6 +98,6 @@
 					$dbConfigValues['workflow_database_type']
 				);
-				$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBGalaxia']);
-				$this->cache['DBGalaxia']->Link_ID = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $this->cache['DBGalaxia']->Link_ID);
+				Factory::getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBGalaxia']);
+				$this->cache['DBGalaxia']->Link_ID = Factory::newInstance('WorkflowWatcher', $this->cache['DBGalaxia']->Link_ID);
 			}
 			else
@@ -128,5 +128,5 @@
 			if (!isset($connectionInfo['db_name']))
 			{
-				$GLOBALS['workflow']['factory']->getInstance('WorkflowMacro')->prepareEnvironment();
+				Factory::getInstance('WorkflowMacro')->prepareEnvironment();
 				if (isset($GLOBALS['phpgw_info']['server']))
 					$connectionInfo = $GLOBALS['phpgw_info']['server'];
@@ -136,5 +136,5 @@
 
 			/* connect to the database */
-			$this->cache['DBExpresso'] = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $GLOBALS['workflow']['factory']->newForeignInstance('phpgwapi', 'db'));
+			$this->cache['DBExpresso'] = Factory::newInstance('WorkflowWatcher', Factory::newInstance('db'));
 			$this->cache['DBExpresso']->disconnect(); /* for some reason it won't connect to the desired database unless we disconnect it first */
 			$this->cache['DBExpresso']->Halt_On_Error = 'no';
@@ -147,6 +147,6 @@
 				$connectionInfo['db_type']
 			);
-			$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBExpresso']);
-			$this->cache['DBExpresso']->Link_ID = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $this->cache['DBExpresso']->Link_ID);
+			Factory::getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBExpresso']);
+			$this->cache['DBExpresso']->Link_ID = Factory::newInstance('WorkflowWatcher', $this->cache['DBExpresso']->Link_ID);
 		}
 
@@ -177,5 +177,5 @@
 
 			/* connect to the database */
-			$this->cache['DBWorkflow'] = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $GLOBALS['workflow']['factory']->newForeignInstance('phpgwapi', 'db'));
+			$this->cache['DBWorkflow'] = Factory::newInstance('WorkflowWatcher', Factory::newInstance('db'));
 			$this->cache['DBWorkflow']->disconnect(); /* for some reason it won't connect to the desired database unless we disconnect it first */
 			$this->cache['DBWorkflow']->Halt_On_Error = 'no';
@@ -188,6 +188,6 @@
 				$dbConfigValues['database_type']
 			);
-			$GLOBALS['workflow']['factory']->getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBWorkflow']);
-			$this->cache['DBWorkflow']->Link_ID = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $this->cache['DBWorkflow']->Link_ID);
+			Factory::getInstance('WorkflowSecurity')->removeSensitiveInformationFromDatabaseObject($this->cache['DBWorkflow']);
+			$this->cache['DBWorkflow']->Link_ID = Factory::newInstance('WorkflowWatcher', $this->cache['DBWorkflow']->Link_ID);
 		}
 
Index: sandbox/workflow/branches/609/inc/class.bo_ajaxinterface.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.bo_ajaxinterface.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.bo_ajaxinterface.inc.php	(revision 2233)
@@ -67,12 +67,12 @@
 		{
 			$GLOBALS['ajax']->ldap = new ajax_ldap();
-			$GLOBALS['ajax']->db = &$GLOBALS['workflow']['workflowObjects']->getDBExpresso();
+			$GLOBALS['ajax']->db =& Factory::getInstance('WorkflowObjects')->getDBExpresso();
 			$GLOBALS['ajax']->db->Halt_On_Error = 'no';
 
-			$GLOBALS['ajax']->db_workflow = &$GLOBALS['workflow']['workflowObjects']->getDBWorkflow();
+			$GLOBALS['ajax']->db_workflow =& Factory::getInstance('WorkflowObjects')->getDBWorkflow();
 			$GLOBALS['ajax']->db_workflow->Halt_On_Error = 'no';
 
 			$GLOBALS['phpgw']->ADOdb = &$GLOBALS['ajax']->db->Link_ID;
-			$GLOBALS['ajax']->acl = new so_adminaccess($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			$GLOBALS['ajax']->acl = new so_adminaccess(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 		else
Index: sandbox/workflow/branches/609/inc/class.UserPictureProvider.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.UserPictureProvider.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.UserPictureProvider.inc.php	(revision 2233)
@@ -114,5 +114,5 @@
 					/* em último caso, tenta buscar a informação em banco de dados */
 					/* prepara o ambiente para a carga de informações sobre o banco de dados */
-					$result = $GLOBALS['workflow']['workflowObjects']->getDBExpresso()->Link_ID->query('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'files_dir'));
+					$result = Factory::getInstance('WorkflowObjects')->getDBExpresso()->Link_ID->query('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'files_dir'));
 					if (empty($result))
 						return;
@@ -141,5 +141,5 @@
 				mkdir($baseDirectory, 0770, true);
 
-			$contents = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getUserPicture($this->userID);
+			$contents = Factory::getInstance('WorkflowLDAP')->getUserPicture($this->userID);
 			$success = true;
 			if ($contents !== false)
@@ -165,5 +165,5 @@
 		}
 
-		$GLOBALS['workflow']['factory']->getInstance('ResourcesRedirector')->show($filename);
+		Factory::getInstance('ResourcesRedirector')->show($filename);
 	}
 }
Index: sandbox/workflow/branches/609/inc/class.ui_external_applications.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.ui_external_applications.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.ui_external_applications.inc.php	(revision 2233)
@@ -49,5 +49,5 @@
 	function draw()
 	{
-		if (!$GLOBALS['workflow']['factory']->getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
+		if (!Factory::getInstance('workflow_acl')->checkWorkflowAdmin($GLOBALS['phpgw_info']['user']['account_id']))
 		{
 			$GLOBALS['phpgw']->common->phpgw_header();
Index: sandbox/workflow/branches/609/inc/class.workflow_rolemanager.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.workflow_rolemanager.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.workflow_rolemanager.inc.php	(revision 2233)
@@ -17,5 +17,5 @@
 		function workflow_rolemanager()
 		{
-			parent::RoleManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::RoleManager(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/branches/609/inc/class.so_agent.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.so_agent.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.so_agent.inc.php	(revision 2233)
@@ -26,8 +26,8 @@
 {
 	//public functions
-	
+
 	/**
 	 * @var array $public_functions Array of public functions
-	 * @access public 
+	 * @access public
 	 */
 	var $public_functions = array(
@@ -36,34 +36,34 @@
 	);
 	/**
-	 * @var array $wf_table 
+	 * @var array $wf_table
 	 * @access public
 	 */
 	var $wf_table = 'egw_wf_agent_';
 	/**
-	 * @var string $agent_table 
+	 * @var string $agent_table
 	 * @access public
 	 */
 	var $agent_table = '';
-	
+
 	// link to the global db-object
-	
+
 	/**
-	 * @var object $db objeto para conexao do banco de dados 
+	 * @var object $db objeto para conexao do banco de dados
 	 * @access public
 	 */
 	var $db;
-	
+
 	/**
 	 * Constructor of the so_agent class
 	 * do not forget to call it (parent::so_agent();) in child classes
 	 * @access public
-	 * @return object 
+	 * @return object
 	 */
-	
+
 	function so_agent()
 	{
-		$this->db =& $GLOBALS['workflow']['workflowObjects']->getDBGalaxia();
+		$this->db =& Factory::getInstance('WorkflowObjects')->getDBGalaxia();
 	}
-	
+
 	/**
 	 * @abstract read all agent datas from the database
Index: sandbox/workflow/branches/609/inc/class.WorkflowSecurity.inc.php
===================================================================
--- sandbox/workflow/branches/609/inc/class.WorkflowSecurity.inc.php	(revision 795)
+++ sandbox/workflow/branches/609/inc/class.WorkflowSecurity.inc.php	(revision 2233)
@@ -51,5 +51,5 @@
 	{
 		/* garante que o objeto de DataBase do Expresso estará disponível */
-		$GLOBALS['workflow']['workflowObjects']->getDBExpresso();
+		Factory::getInstance('WorkflowObjects')->getDBExpresso();
 	}
 
@@ -77,5 +77,5 @@
 				continue;
 			$this->removeSensitiveInformationFromDatabaseObject($variable);
-			$variable = $GLOBALS['workflow']['factory']->newInstance('WorkflowWatcher', $variable);
+			$variable = Factory::newInstance('WorkflowWatcher', $variable);
 		}
 	}
